import { IsCompleteResponse, OnEventResponse } from '@aws-cdk/custom-resources/lib/provider-framework/types';
import * as aws from 'aws-sdk';
export declare class ClusterResourceHandler {
    private readonly eks;
    get clusterName(): string;
    private readonly requestType;
    private readonly requestId;
    private readonly logicalResourceId;
    private readonly physicalResourceId?;
    private readonly newProps;
    private readonly oldProps;
    constructor(eks: EksClient, event: any);
    onEvent(): Promise<OnEventResponse | aws.EKS.UpdateClusterConfigResponse | undefined>;
    isComplete(): Promise<IsCompleteResponse>;
    private onCreate;
    private isCreateComplete;
    private onDelete;
    private isDeleteComplete;
    private onUpdate;
    private isUpdateComplete;
    private updateClusterVersion;
    private isActive;
    private generateClusterName;
}
export interface EksClient {
    configureAssumeRole(request: aws.STS.AssumeRoleRequest): void;
    createCluster(request: aws.EKS.CreateClusterRequest): Promise<aws.EKS.CreateClusterResponse>;
    deleteCluster(request: aws.EKS.DeleteClusterRequest): Promise<aws.EKS.DeleteClusterResponse>;
    describeCluster(request: aws.EKS.DescribeClusterRequest): Promise<aws.EKS.DescribeClusterResponse>;
    updateClusterConfig(request: aws.EKS.UpdateClusterConfigRequest): Promise<aws.EKS.UpdateClusterConfigResponse>;
    updateClusterVersion(request: aws.EKS.UpdateClusterVersionRequest): Promise<aws.EKS.UpdateClusterVersionResponse>;
}
